// BonTsDemuxDlg.cpp : t@C
//

#include "stdafx.h"
#include "BonTsDemux.h"
#include "BonTsDemuxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBonTsDemuxDlg _CAO
CBonTsDemuxDlg::CBonTsDemuxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBonTsDemuxDlg::IDD, pParent)
	, m_TsConverter(this)
	, m_csTsPath(_T(""))
	, m_csVideoPath(_T(""))
	, m_csAudioPath(_T(""))
	, m_bVideoOut(TRUE)
	, m_bAudioOut(TRUE)
	, m_bAacDecode(FALSE)
	, m_bLipSync(FALSE)
	, m_bTestMode(FALSE)
	, m_wSelectServiceID(NO_SERVICE_SELECT)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBonTsDemuxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_TSPATH, m_csTsPath);
	DDX_Text(pDX, IDC_VIDEOPATH, m_csVideoPath);
	DDX_Text(pDX, IDC_AUDIOPATH, m_csAudioPath);
	DDX_Check(pDX, IDC_VIDEOOUT, m_bVideoOut);
	DDX_Check(pDX, IDC_AUDIOOUT, m_bAudioOut);
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Check(pDX, IDC_AACDECODE, m_bAacDecode);
	DDX_Check(pDX, IDC_LIPSYNC, m_bLipSync);
}

BEGIN_MESSAGE_MAP(CBonTsDemuxDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BROWSETS, &CBonTsDemuxDlg::OnBnClickedBrowseTs)
	ON_BN_CLICKED(IDC_BROWSEVIDEO, &CBonTsDemuxDlg::OnBnClickedBrowseVideo)
	ON_BN_CLICKED(IDC_BROWSEAUDIO, &CBonTsDemuxDlg::OnBnClickedBrowseAudio)
	ON_BN_CLICKED(IDC_VIDEOOUT, &CBonTsDemuxDlg::OnBnClickedVideoOut)
	ON_BN_CLICKED(IDC_AUDIOOUT, &CBonTsDemuxDlg::OnBnClickedAudioOut)
	ON_BN_CLICKED(IDC_START, &CBonTsDemuxDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CBonTsDemuxDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_AACDECODE, &CBonTsDemuxDlg::OnBnClickedAacDecode)
END_MESSAGE_MAP()


// CBonTsDemuxDlg bZ[W nh

BOOL CBonTsDemuxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBonTsDemuxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBonTsDemuxDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBonTsDemuxDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CBonTsDemuxDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
}

void CBonTsDemuxDlg::OnBnClickedBrowseTs()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(TRUE, TEXT("ts"), NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TEXT("TSt@C (*.ts)|*.ts|Mpeg2TSt@C (*.m2t)|*.m2t||"));

	if(Dlg.DoModal() == IDOK){
		// T[rXI{bNXNAĐ擪TEST_READ_SIZEt@CeXgs
		CComboBox *pServiceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SVCOMBO));
		pServiceCombo->ResetContent();		

		m_csTsPath = Dlg.GetPathName();

		m_bTestMode = TRUE;
		const bool bReturn = m_TsConverter.ConvertTsFile(m_csTsPath, TEST_READ_SIZE, NO_SERVICE_SELECT, NULL, NULL);
		
		if(bReturn){
			m_csVideoPath = m_csTsPath;
			m_csVideoPath.Replace(TEXT(".ts"), TEXT(".m2v"));
			m_csVideoPath.Replace(TEXT(".m2t"), TEXT(".m2v"));
			
			m_csAudioPath = m_csTsPath;
			m_csAudioPath.Replace(TEXT(".ts"), TEXT(".aac"));
			m_csAudioPath.Replace(TEXT(".m2t"), TEXT(".aac"));
			}
				
		UpdateData(FALSE);
		}
}

void CBonTsDemuxDlg::OnBnClickedBrowseVideo()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(FALSE, TEXT("m2v"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("m2vt@C (*.m2v)|*.m2v||"));
	if(Dlg.DoModal() != IDOK)return;

	m_csVideoPath = Dlg.GetPathName();

	UpdateData(FALSE);
}

void CBonTsDemuxDlg::OnBnClickedBrowseAudio()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(FALSE, TEXT("aac"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("aact@C (*.aac)|*.aac|wavt@C (*.wav)|*.wav||"));
	if(Dlg.DoModal() != IDOK)return;
	
	m_csAudioPath = Dlg.GetPathName();
	m_bAacDecode = (Dlg.GetFileExt() == TEXT("aac"))? false : true;
		
	UpdateData(FALSE);
}

void CBonTsDemuxDlg::OnBnClickedVideoOut()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);
	
	GetDlgItem(IDC_VIDEOPATH)->EnableWindow(m_bVideoOut);
	GetDlgItem(IDC_BROWSEVIDEO)->EnableWindow(m_bVideoOut);
}

void CBonTsDemuxDlg::OnBnClickedAudioOut()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);
	
	GetDlgItem(IDC_AUDIOPATH)->EnableWindow(m_bAudioOut);
	GetDlgItem(IDC_AACDECODE)->EnableWindow(m_bAudioOut);
	GetDlgItem(IDC_BROWSEAUDIO)->EnableWindow(m_bAudioOut);
	GetDlgItem(IDC_LIPSYNC)->EnableWindow(m_bAudioOut);
}

void CBonTsDemuxDlg::OnBnClickedAacDecode()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);
	
	if(m_bAacDecode){
		m_csAudioPath.Replace(TEXT(".aac"), TEXT(".wav"));
		}
	else{
		m_csAudioPath.Replace(TEXT(".wav"), TEXT(".aac"));
		}
		
	UpdateData(FALSE);
}

void CBonTsDemuxDlg::OnBnClickedStart()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	OnBnClickedAacDecode();

	CComboBox *pServiceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SVCOMBO));
	m_wSelectServiceID = NO_SERVICE_SELECT;
	int iSelPos = pServiceCombo->GetCurSel();
	if(iSelPos!=-1)
	{
		m_wSelectServiceID = static_cast<WORD>(pServiceCombo->GetItemData(iSelPos));
	}
	
	if(!m_bVideoOut && !m_bAudioOut){
		::AfxMessageBox(TEXT("rfI܂̓I[fBIo͐ݒɂĂB"));
		return;
		}
	
	// Ro[gJn
	m_bTestMode = FALSE;
	const bool bReturn = m_TsConverter.ConvertTsFile(m_csTsPath,READ_TO_FILEEND,m_wSelectServiceID,
													(m_bVideoOut)? (LPCTSTR)m_csVideoPath : NULL,
													(m_bAudioOut)? (LPCTSTR)m_csAudioPath : NULL,
													(m_bAacDecode)? true : false,
													(m_bLipSync)? true : false
													);
	
	if(!bReturn){
		::AfxMessageBox(TEXT("t@C̃I[vɎs܂B"));
		}
}

void CBonTsDemuxDlg::OnBnClickedStop()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_TsConverter.CancelConvert();
}

void CBonTsDemuxDlg::LockControl(const BOOL bLock)
{
	// Rg[bN
	const BOOL bEnable = (bLock)? FALSE : TRUE;

	GetDlgItem(IDC_START)->EnableWindow(bEnable);
	GetDlgItem(IDC_BROWSETS)->EnableWindow(bEnable);
	GetDlgItem(IDC_BROWSEVIDEO)->EnableWindow(bEnable && m_bVideoOut);
	GetDlgItem(IDC_BROWSEAUDIO)->EnableWindow(bEnable && m_bAudioOut);
	GetDlgItem(IDC_TSPATH)->EnableWindow(bEnable);
	GetDlgItem(IDC_VIDEOOUT)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUDIOOUT)->EnableWindow(bEnable);
	GetDlgItem(IDC_VIDEOPATH)->EnableWindow(bEnable && m_bVideoOut);
	GetDlgItem(IDC_AUDIOPATH)->EnableWindow(bEnable && m_bAudioOut);
	GetDlgItem(IDC_AACDECODE)->EnableWindow(bEnable && m_bAudioOut);
	GetDlgItem(IDC_LIPSYNC)->EnableWindow(bEnable && m_bAudioOut);
	GetDlgItem(IDC_SVCOMBO)->EnableWindow(bEnable);
}

void  CBonTsDemuxDlg::OnTsConverterStart(const ULONGLONG llFileSize)
{
	// ϊJnCxg
	LockControl(TRUE);
	m_Progress.SetRange(0, 1000);

	m_Progress.SetPos(0);
}

void  CBonTsDemuxDlg::OnTsConverterEnd(const ULONGLONG llFileSize)
{
	// ϊICxg
	if(m_bTestMode){
		SetDlgItemText(IDC_INFOVIEW, TEXT("Jnł܂"));
		m_Progress.SetPos(0);
	} else {
		SetDlgItemText(IDC_INFOVIEW, TEXT("ϊ܂"));
		}

	LockControl(FALSE);
}

void CBonTsDemuxDlg::OnTsConverterProgress(const ULONGLONG llCurPos, const ULONGLONG llFileSize)
{
	// iXVCxg
	m_Progress.SetPos((int)((llCurPos * 1000ULL) / llFileSize));
}

void CBonTsDemuxDlg::OnTsConverterServiceName(LPCTSTR lpszServiceName)
{
	// T[rXXVCxg
	CString csText;
	csText.Format(TEXT("T[rXF %s"), lpszServiceName);
	SetDlgItemText(IDC_INFOVIEW, csText);
}

void CBonTsDemuxDlg::OnTsConverterServiceInfo(CProgManager *pProgManager)
{
	// T[rXXgXVCxg
	CComboBox *pServiceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SVCOMBO));

	int iCurSel = pServiceCombo->GetCurSel();
	if(pServiceCombo->GetCount()==0) iCurSel = -1;
	WORD wCurServiceSel = static_cast<WORD>(pServiceCombo->GetItemData(iCurSel));
	if(!m_bTestMode){
		wCurServiceSel = m_wSelectServiceID;
		}
	pServiceCombo->ResetContent();
	TCHAR szServiceName[1024];
	WORD wServiceID;
	bool bSelected = false;
	
	// T[rXXV
	for(WORD wIndex = 0U ; wIndex < pProgManager->GetServiceNum() ; wIndex++){
		if(pProgManager->GetServiceID(&wServiceID, wIndex)){
			CString Str;
			if(pProgManager->GetServiceName(szServiceName, wIndex)){				
				Str.Format(TEXT("%5d : %s"),wServiceID,szServiceName);
				}
			else{				
				Str.Format(TEXT("%5d : T[rX擾..."),wServiceID);
				}
			// T[rXXV
			int iPos = pServiceCombo->AddString(Str);
			pServiceCombo->SetItemData(iPos,wServiceID);
			// XgύXOɑIĂACeȂđI
			if(iCurSel != -1){
				if(wCurServiceSel==wServiceID){
					pServiceCombo->SetCurSel(iPos);
					bSelected = true;
					}
				}
			}			
		}
	// I܂ȂꍇAԏ̃ACeI
	if(!bSelected || m_bTestMode){
		pServiceCombo->SetCurSel(0);
		}
}